signature DeflateBits =
sig

	type byte
	
	(*
	 convert boolean to integer or character
	*)
	
	val bit_to_int : bool -> int
	
	val bit_to_char : bool -> char
	
	(*
	 parity
	 *)
	
	val is_odd : int -> bool
	
	val is_even : int -> bool
	
	(*
	 byte routines
	 *)
	
	val byte_to_char : byte -> char
	
	val char_to_byte : char -> byte
	
	val is_byte_zero : byte -> bool
	
	val int_to_byte : int -> byte
	
	val byte_eq : byte * byte -> bool
	
	val byte_bit : int -> byte -> bool
	(* bit out of byte; index in 0..7, 0 is least significant *)
	
	val byte_sub : int * int -> byte -> int
	(*
	  (int,int): from, to position within 0-7
	  byte: input byte
	  int: result conversion of subset of byte into integer
	*)
	
	(*
	 convert integer into list of boolean, lsb or msb first
	 int : number of bits in result
	 int|byte : integer to convert
	 bool list : result
	*)
	
	val explode_fixed_lsb_first : int -> int -> bool list
	
	val explode_fixed_msb_first : int -> int -> bool list
	
	val explode_byte_lsb_first : int -> byte -> bool list

	(*
	 convert list of boolean to integer, lsb or msb first
	*)
	
	val to_int_lsb_first : bool list -> int
	
	val to_int_msb_first : bool list -> int
	
	val to_string : bool list -> string
	
	(*
	 misc
	*)
	
	val pow2 : int -> int
		
	(* self test *)
	val tests: bool list  
	 
end
