signature DeflateList =
sig

	(*
	 list routines
	*)
	
	val sort : ('a * 'a -> bool) -> 'a list -> 'a list
	(* sort a list *)
	
	val sorted : ('a * 'a -> bool) -> 'a list -> bool
	(* is the list sorted? *)
	
	val enum : int -> int -> int list
	(* [first .. second] *)
	 
	val replicate : int -> 'a -> 'a list
	(* value 'a repeated int times *)
	
	val trim : 'a list -> int -> 'a list
	(* 
	  like List.take (list, min (length list, int), 
	  that is no exception if int larger than list 
	*)

	(* 
	  list-like function for state operations of the type
       f : state -> (out * newstate)
	*)
	
	val state_map : ('a -> 'b * 'a) list -> 'a -> 'b list * 'a

	(* tests *)
	val tests: bool list
	
end
